#include <Azande.h>

// Global variables
define_target_info(targetInfo, "UNO + Prototype Shield", "1.0", "2018-01-22", "Note: Tester");

define_void_command(cmdRestartSystem, "Restart System", 0, RestartSystem);
define_bool_command(cmdSetRedLed, "Set Red LED", 4, setRedLed, "ON", "OFF" );
define_int_command(cmdSetDac1, "Set DAC1", 2, SetDac1, "steps", 0, 1023);
define_int_command(cmdSetCounter, "Set Counter", 11, SetCounter, , , );
define_double_command(cmdSetBacklightVoltage, "Set Backlight Voltage", 0, SetBacklightVoltage, "V", 0.0, 3.3 );
define_double_command(cmdSetPercentage, "Set Percentage", 10, SetPercentage, , , );
define_text_command(cmdSetMsgOnDisplay, "Set Msg On Display", 12, SetMsgOnDisplay, 32 );

define_enum_command(cmdSetLedColor, "Set LED Color", 19, SetLedColor,   define_enum_item(0, "Green")\
                                                                        define_enum_item(1, "Red")\
                                                                        define_enum_item(-25, "Blue")\
                                                                        define_enum_item(3, "Yellow")\
                                                                        define_enum_item(23, "White"))

define_bool_event(eventButtonAState, "Button-A State", 6, "Activated", "Not Activated" );
define_int_event(eventWaterLevel, "Water Level", 4, "cm", -30, 30, "D");
define_int_event(eventCounter, "Counter", 11, , , , );
define_double_event(eventAirTemperature, "Air Temperature", 4, "°C", 0.0, 90.0, "F2");
define_double_event(eventPercentage, "Percentage", 10, , , , );
define_text_event(eventMsgFromUser, "Msg From User", 12, 64);

long counter;
double percentage;
int button = 5;
int led = 6;
boolean redLedIsOn = false;
Azande azande;


void setup() 
{
  pinMode(button, INPUT);
  
  pinMode(led, OUTPUT);
  setRedLed(false);
  
  //azande.begin(9600);
  azande.begin(9600, targetInfo);
  
  azande.add(cmdRestartSystem);
  azande.add(cmdSetRedLed);
  azande.add(cmdSetDac1);
  azande.add(cmdSetCounter);
  azande.add(cmdSetLedColor);
  azande.add(cmdSetBacklightVoltage);
  azande.add(cmdSetPercentage);
  azande.add(cmdSetMsgOnDisplay);
  azande.add(eventButtonAState);
  azande.add(eventWaterLevel);
  azande.add(eventCounter);
  azande.add(eventAirTemperature);
  azande.add(eventPercentage);
  azande.add(eventMsgFromUser);
}


void loop() 
{
  static int slot = 0;
  static long waterlevel = 0;
  static double airtemperature = 0;

  delay(100); // [ms]
  switch (slot)
  {
    case 0:
      if (!digitalRead(button)) // High=Not_pushed, Low=Pushed
      {
         azande.send(eventButtonAState, true);
      }
      else
      {
         azande.send(eventButtonAState, false);
      }
      slot = 1;
      break;
    
    case 1:
      ++waterlevel;
      if (waterlevel > 30)
      {
        waterlevel = -30;
      }
      azande.send(eventWaterLevel, waterlevel);
      slot = 2;
      break;
    
    case 2:
    default:
      airtemperature += 1.0;
      if (airtemperature > 90.0)
      {
        airtemperature = 0.0;
      }
      azande.send(eventAirTemperature, airtemperature);
      slot = 0;
      break;
  }
}

void serialEvent() 
{
  azande.serialEvent();
}

void setRedLed(boolean state)
{
  digitalWrite(led, state);
  redLedIsOn = state;
}

void RestartSystem(void)
{
}

void SetDac1(long steps)
{
}

void SetLedColor(long colorId)
{
}

void SetCounter(long count)
{
  counter = count;
  azande.send(eventCounter, counter);
}

void SetBacklightVoltage(double voltage)
{
}

void SetPercentage(double per)
{
  percentage = per;
  azande.send(eventPercentage, percentage);
}

void SetMsgOnDisplay(char* txt, unsigned int length)
{
  char str[64];
  memcpy(str, txt, length);
  str[length] = 0;
  azande.send(eventMsgFromUser, str);
}

